#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>

#define  F_CPU			 (8000000UL)
#define  DIMM_CH         (9)
#define  DMX_CHANNELS    (10)									//use at least 2ch

enum {TICK, BLACK_OUT};													//global flags
enum {SIGNAL_COMING, VALID_DMX, DMX_ERR, DATA_REFRESHED, OVERHEAT}; //indicator / status flags

volatile uint8_t	  DmxField[DMX_CHANNELS];				    //array of DMX vals (raw)
volatile uint8_t	  PdmField[DIMM_CH];
volatile uint8_t 	  gFlags;									//Flags
         uint8_t      IndCnt;
		 uint8_t      IndFlags;
		 uint8_t	  ErrState;
		 


struct durables{						//DURABLE DATA BUFFERED IN EE
  volatile uint16_t	  DmxAddress;		//start address
		   uint8_t	  Personality;		//bit mask for switch channels	
		   uint8_t	  Preheat[DIMM_CH];
		   uint8_t	  Topset[DIMM_CH];	//max limit for all ch
		   uint8_t	  Error[DIMM_CH];	//error scene
		   uint8_t	  DevLabel[20];		//device label
		   uint8_t	  DevLabelLen;		
		   }dur;	



//important static EEPROM data
#define EE_BASE			(0x01)		//start of non volatile buffer





