/**** A P P L I C A T I O N   N O T E   ************************************
*
* Title			: Error Indication Library
* Version		: v1.0
* Last updated	: 09.09.07
* Target		: Transceiver Rev.3.01 [ATmega8515]
* Clock			: 8MHz, 16MHz
*
* written by hendrik hoelscher, www.hoelscher-hi.de
***************************************************************************
 This program is free software; you can redistribute it and/or 
 modify it under the terms of the GNU General Public License 
 as published by the Free Software Foundation; either version2 of 
 the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 General Public License for more details. 

 If you have no copy of the GNU General Public License, write to the 
 Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

 For other license models, please contact the author.

;***************************************************************************/

#include "globals.h"
#include "lib_indicator.h"
#include <string.h>

#define NO_DMX_PAT 	(0b10000010)
#define NO_ZC_PAT	(0b10101010)
#define HOT_PAT		(0b11111111)

		uint8_t Blink= 0xFF;;



static void load_err_pat(void)
{
uint8_t i, val;
val= 0xFF;
for (i=0; i<DIMM_CH; i++)
	{
	if (dur.Error[i] != 0xFF) val= 0;
	}

if (val == 0) memcpy(&DmxField[0], &dur.Error[0], DIMM_CH);
}


// ******************** LED indicator *****************************
void indicate(void)
{
if (IndFlags &(1<<DATA_REFRESHED))
	{
	IndFlags &= ~(1<<DATA_REFRESHED);
	PORTE ^= (1<<PE0);								//change green LED state
	}
else PORTE |= (1<<PE0);								//disable LED if nothing's changed

if (Blink &(1<<0)) PORTD &= ~(1<<PD7);				//enable red LED if 1st bit is set
else PORTD |= (1<<PD7);

Blink= (Blink>>1);									//shift pattern
if (Blink <= 1)
	{
	if (IndFlags &(1<<OVERHEAT))
		{
		Blink= HOT_PAT;
		ErrState= 2;
		} 
	else if (!(IndFlags &(1<<VALID_DMX)))
		{
		load_err_pat();
		Blink= NO_DMX_PAT;
		ErrState= 0;
		}
	else
		{
		Blink= 0b10000000;
		ErrState= 0;
		}
	IndFlags &= ~(1<<VALID_DMX);			//clear Flags
	}
}
